<?php
namespace Teknisa\DF\Services;

use Teknisa\Libs\Util\Environment;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\DataSet;
use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DTO;


class Ger97500TipoOpercaoCfopService{

	protected $environment;
	protected $entityManager;
	protected $dataSourceManager;

	public function __construct(Environment $environment, \Doctrine\ORM\EntityManager $entityManager ,$dataSourceManager){
		$this->environment = $environment;
		$this->entityManager = $entityManager;
		$this->dataSourceManager = $dataSourceManager;
	}

	public function deletar($row){
		try {
	        $connection = $this->entityManager->getConnection();
	       	$connection->beginTransaction();
	        $conditions = $this->condicaodeletar($row);
		    $resultadoBanco = $this->buscar($conditions,'tpopercfopexcp_produto_tipooperac');
	    	if(empty($resultadoBanco->getRows())){
		        $array[] = $row;
		        $dataSet = new DataSet('tpopercfop', $array);
		        $this->delete($dataSet);
	    	}else{
		        $this->delete($resultadoBanco);

	    		$arrayTipoOperacao[] = $row;
		        $dataSetTipoOperacao = new DataSet('tpopercfop', $arrayTipoOperacao);
		        $this->delete($dataSetTipoOperacao);
	    	}
			$connection->commit();
		}catch (\Exception $e) {
    		$this->entityManager->rollback();
        	throw $e;
        }
	}

	public function condicaodeletar($row) {
	    $conditions = array(
	      array(
	        "value" => $this->environment->getNrOrgTrab(),
	        "operator" => "=",
	        "columnName" => "NRORG"
	      ),
	      array(
	        "value" => $row['IDENTRSAIDOP'],
	        "operator" => "=",
	        "columnName" => "IDENTRSAIDOP"
	      ),
	      array(
	        "value" => $row['CDTIPOOPER'],
	        "operator" => "=",
	        "columnName" => "CDTIPOOPER"
	      ),
	      array(
	        "value" => $row['CDFISCOPER'],
	        "operator" => "=",
	        "columnName" => "CDFISCOPER"
	      )
	    );
	    return $conditions;
	}

	public function buscar($conditions, $dataSourceName){
		$filterCriteria = new FilterCriteria($dataSourceName,$conditions);
		return  $this->dataSourceManager->findBy($filterCriteria);

	}

	public function delete($dataSet){
    	$this->dataSourceManager->delete($dataSet);
    	$this->entityManager->flush();
	}
}